<?php
/**
 * Created by PhpStorm.
 * User: ddcai
 * Date: 2018/6/11
 * Time: 13:40
 */

class gzhq_factory extends gzhq_base{
	
    //工厂生产产品
    public function factory_act(){
		$return_arr = array(
			"ga"	=> 'game_txt_tip',
			"code"	=> 1,
			"gd"	=> array(
				'uid'=>0,
				'msg'=>"fail"
			)
		);
		
		$redis_conn = $this->arr['server']->redis_pool->get();
        $mysql_conn = $this->arr['server']->mysql_pool->get();
		$tmp_user_info = $this->arr['server']->get_user_by_fd($this->arr['fd']);
		if($tmp_user_info['uid']) {//如果用户登陆正常
			$uid = $tmp_user_info['uid'];
			
			$ip = $this->arr['ip'];
			$mf_id	= $this->arr['d']["mf_id"];	//工厂ID
			$id		= $this->arr['d']["id"];	//要生产的物品ID
			if( empty($mf_id) || empty($id) ){
				$return_arr["gd"]["msg"] = "数据不能为空";
				$this->arr['server']->redis_pool->put($redis_conn);
				$this->arr['server']->mysql_pool->put($mysql_conn);
				$this->arr['server']->send_user($this->arr['fd'],$return_arr);
				return true;
			}
			
			$user_prop = get_game_user_prop($uid,$mysql_conn,$redis_conn);//用户属性
			
			//工厂数据
			$factory_info = $GLOBALS["SYS_FACTORY_INFO"][$mf_id];
			//物品数据
			$good_info = $GLOBALS["SYS_GOOD_INFO"][$id];//
			//工厂可生产物品的数据
			$factory_goods = $GLOBALS["SYS_FACTORY_GOOD"][$mf_id][$id];
			
			if(!$factory_info || !$good_info || !$factory_goods){
				$return_arr["gd"]["msg"] = "获取数据出错";
				$this->arr['server']->redis_pool->put($redis_conn);
				$this->arr['server']->mysql_pool->put($mysql_conn);
				$this->arr['server']->send_user($this->arr['fd'],$return_arr);
				return true;
			}
			
			if($user_prop['grade']<$good_info['grade']){
				$return_arr["gd"]["msg"] = "你的等级不够";
				$this->arr['server']->redis_pool->put($redis_conn);
				$this->arr['server']->mysql_pool->put($mysql_conn);
				$this->arr['server']->send_user($this->arr['fd'],$return_arr);
				return true;
			}
			
			//用户工厂数据
			$user_factory = get_game_user_factory_info($uid,$mf_id,array(),$mysql_conn,$redis_conn);
			if(!$user_factory){
				$return_arr["gd"]["msg"] = "工厂没建造";
				$this->arr['server']->redis_pool->put($redis_conn);
				$this->arr['server']->mysql_pool->put($mysql_conn);
				$this->arr['server']->send_user($this->arr['fd'],$return_arr);
				return true;
			}
			
			if($user_factory['grade']<$factory_goods['grade']){
				$return_arr["gd"]["msg"] = "工厂等级不够，不能生产该物品";
				$this->arr['server']->redis_pool->put($redis_conn);
				$this->arr['server']->mysql_pool->put($mysql_conn);
				$this->arr['server']->send_user($this->arr['fd'],$return_arr);
				return true;
			}
			
			if($user_prop['grade']<$factory_goods['grade2']){
				$return_arr["gd"]["msg"] = "你的等级不够，不能生产该物品";
				$this->arr['server']->redis_pool->put($redis_conn);
				$this->arr['server']->mysql_pool->put($mysql_conn);
				$this->arr['server']->send_user($this->arr['fd'],$return_arr);
				return true;
			}
			//判断物品数量
			$check_goods = check_user_good($uid,$factory_goods['good'],$mysql_conn,$redis_conn);
			if(!$check_goods){
				$return_arr["gd"]["msg"] = "没有足够商品队列";
				$this->arr['server']->redis_pool->put($redis_conn);
				$this->arr['server']->mysql_pool->put($mysql_conn);
				$this->arr['server']->send_user($this->arr['fd'],$return_arr);
				return true;
			}
			
			$del_goods = del_user_good($uid,$ip,$factory_goods['good'],$mysql_conn,$redis_conn);
			if(!$del_goods){
				$return_arr["gd"]["msg"] = "扣除材料失败";
				$this->arr['server']->redis_pool->put($redis_conn);
				$this->arr['server']->mysql_pool->put($mysql_conn);
				$this->arr['server']->send_user($this->arr['fd'],$return_arr);
				return true;
			}
			
			$being_goods = $user_factory['being_goods']?json_decode($user_factory['being_goods'],true):'';//正在生产的物品
			$queue_goods = $user_factory['queue_goods']?json_decode($user_factory['queue_goods'],true):'';//正在队列生产的物品
			
			$tmp_time = time();
			
			//生产速度 = 工厂可生产物品基础速度+工厂等级加速度
			$speed = $factory_goods['speed']+$factory_info[$user_factory['grade']]['speed'];
			$t2 = round($factory_goods['t']/$speed);//结束时间
			
			
			
			if($being_goods){
				$tol_queue_goods = $queue_goods?count($queue_goods):0;
				if(strtotime($being_goods['t2'])-$tmp_time>0 && $tol_queue_goods>=$user_factory['open_seat_num'] ){
					$return_arr["gd"]["msg"] = "没有足够商品队列";
					$this->arr['server']->redis_pool->put($redis_conn);
					$this->arr['server']->mysql_pool->put($mysql_conn);
					$this->arr['server']->send_user($this->arr['fd'],$return_arr);
					return true;
				}
				$tmp_being_goods = $being_goods;
				//如果生产队列在用 则加入生产队列
				$tmp_queue_goods = factory_goods_queue($id,$t2,$being_goods,$queue_goods);
				
			}else{
				//生产物品数据
				$add_being_goods = array(
					'id'	=> $id,//生产物品的ID
					't'		=> date("Y-m-d H:i:s",$tmp_time),//开始生产时间
					't2'	=> date("Y-m-d H:i:s",$t2+$tmp_time),//生产完成时间
					'n'		=> 1 //生产物品个数
				);	
				$tmp_being_goods = $add_being_goods;
			}
			
			$up_arr = array(
				'used_seat_num'	=> count($tmp_queue_goods),	//已用生产位数量
				'being_goods'	=> $tmp_being_goods?json_encode($tmp_being_goods,JSON_UNESCAPED_UNICODE ):'',	//正在生产的物品
				'queue_goods'	=> $tmp_queue_goods?json_encode($tmp_queue_goods,JSON_UNESCAPED_UNICODE ):'',	//准备生产的物品队列
			);
			$info = update_game_user_factory($uid,$mf_id,$up_arr,$mysql_conn,$redis_conn);
			if($info){
				
				//添加用户工厂生产产品日志
				$add_arr = array(
					'uid'		=> $uid,
					'mf_id'		=> $mf_id,
					'mf_vip'	=> $user_factory['grade'],
					'gold'		=> 0,//所需宝石
					'goods_num'	=> $id,//'物品编号'
					'add_time'	=> date("Y-m-d H:i:s", time()),
					'info'		=> $factory_goods['name'].'生产'
				);
				add_member_factory_output_log($add_arr,$mysql_conn,$redis_conn);
				
				//获取工厂新的生产数据
				$new_user_factory = get_game_user_factory_info($uid,$mf_id,array(),$mysql_conn,$redis_conn);
				$new_goods_info = get_factory_goods($uid,$new_user_factory,$mysql_conn,$redis_conn);//计算返回物品数据
				$return_arr = array(
					"ga"	=> 'factory_act_bak',
					"code"	=> 1,
					"gd"	=> array(
						'mf_id'			=> $new_user_factory['mf_id'],//工厂ID
						'grade'			=> $new_user_factory['grade'],//工厂等级
						'open_seat_num'	=> $new_user_factory['open_seat_num'],//已经打开的栏位数量
						'being_goods'	=> $new_goods_info['being_goods'],//正在生产中的物品
						'queue_goods'	=> $new_goods_info['queue_goods'],//等待生产的物品
						'succ_goods'	=> $new_goods_info['succ_goods'],//已经生产完成的物品
						'msg'			=> '生产成功'
					)	
				);
			}else{
				$return_arr["gd"]["msg"] = "生产失败";
			}
			$this->arr['server']->redis_pool->put($redis_conn);
			$this->arr['server']->mysql_pool->put($mysql_conn);
			$this->arr['server']->send_user($this->arr['fd'],$return_arr);
			return true;
		}else{
			echo("用户不在线:fd=".$this->arr['fd']."||uid=".$tmp_user_info['uid']);
        }
        $this->arr['server']->redis_pool->put($redis_conn);
        $this->arr['server']->mysql_pool->put($mysql_conn);
        return true;
    }
	
	 // 工厂生产产品完成
    public function factory_good_get(){
		$return_arr = array(
			"ga"	=> 'game_txt_tip',
			"code"	=> 1,
			"gd"	=> array(
				'uid'=>0,
				'msg'=>"fail"
			)
		);
		
		$redis_conn = $this->arr['server']->redis_pool->get();
        $mysql_conn = $this->arr['server']->mysql_pool->get();
		$tmp_user_info = $this->arr['server']->get_user_by_fd($this->arr['fd']);
		if($tmp_user_info['uid']) {//如果用户登陆正常
			$uid = $tmp_user_info['uid'];
			
			$ip = $this->arr['ip'];
			$mf_id	= $this->arr['d']["mf_id"];	//工厂ID
			if( empty($mf_id) ){
				$return_arr["gd"]["msg"] = "数据不能为空";
				$this->arr['server']->redis_pool->put($redis_conn);
				$this->arr['server']->mysql_pool->put($mysql_conn);
				$this->arr['server']->send_user($this->arr['fd'],$return_arr);
				return true;
			}
			
			$user_prop = get_game_user_prop($uid,$mysql_conn,$redis_conn);//用户属性
			
			//工厂数据
			$factory_info = $GLOBALS["SYS_FACTORY_INFO"][$mf_id];
			if(!$factory_info){
				$return_arr["gd"]["msg"] = "获取数据出错";
				$this->arr['server']->redis_pool->put($redis_conn);
				$this->arr['server']->mysql_pool->put($mysql_conn);
				$this->arr['server']->send_user($this->arr['fd'],$return_arr);
				return true;
			}
			//用户工厂数据
			$user_factory = get_game_user_factory_info($uid,$mf_id,array(),$mysql_conn,$redis_conn);
			if(!$user_factory){
				$return_arr["gd"]["msg"] = "工厂没建造";
				$this->arr['server']->redis_pool->put($redis_conn);
				$this->arr['server']->mysql_pool->put($mysql_conn);
				$this->arr['server']->send_user($this->arr['fd'],$return_arr);
				return true;
			}
			
			if($user_factory){
				
				//获取工厂新的生产数据
				$new_user_factory = get_game_user_factory_info($uid,$mf_id,array(),$mysql_conn,$redis_conn);
				$new_goods_info = get_factory_goods($uid,$new_user_factory,$mysql_conn,$redis_conn);//计算返回物品数据
				$return_arr = array(
					"ga"	=> 'factory_good_get_bak',
					"code"	=> 1,
					"gd"	=> array(
						'mf_id'			=> $new_user_factory['mf_id'],//工厂ID
						'grade'			=> $new_user_factory['grade'],//工厂等级
						'open_seat_num'	=> $new_user_factory['open_seat_num'],//已经打开的栏位数量
						'being_goods'	=> $new_goods_info['being_goods'],//正在生产中的物品
						'queue_goods'	=> $new_goods_info['queue_goods'],//等待生产的物品
						'succ_goods'	=> $new_goods_info['succ_goods'],//已经生产完成的物品
						'msg'			=> '生产完成成功'
					)	
				);
			}else{
				$return_arr["gd"]["msg"] = "生产完成失败";
			}
			
			$this->arr['server']->redis_pool->put($redis_conn);
			$this->arr['server']->mysql_pool->put($mysql_conn);
			$this->arr['server']->send_user($this->arr['fd'],$return_arr);
			return true;
		}else{
			echo("用户不在线:fd=".$this->arr['fd']."||uid=".$tmp_user_info['uid']);
        }
        $this->arr['server']->redis_pool->put($redis_conn);
        $this->arr['server']->mysql_pool->put($mysql_conn);
        return true;
    }
	
	//工厂购买生产队列
	public function factory_open_seat_num(){
		$return_arr = array(
			"ga"	=> 'game_txt_tip',
			"code"	=> 1,
			"gd"	=> array(
				'uid'=>0,
				'msg'=>"fail"
			)
		);
		
		$redis_conn = $this->arr['server']->redis_pool->get();
        $mysql_conn = $this->arr['server']->mysql_pool->get();
		$tmp_user_info = $this->arr['server']->get_user_by_fd($this->arr['fd']);
		if($tmp_user_info['uid']) {//如果用户登陆正常
			$uid = $tmp_user_info['uid'];
			
			$ip = $this->arr['ip'];
			$mf_id	= $this->arr['d']["mf_id"];	//工厂ID
			$num	= intval($this->arr['d']["num"]);	//生产队列
			if( empty($mf_id) || empty($num)){
				$return_arr["gd"]["msg"] = "数据不能为空";
				$this->arr['server']->redis_pool->put($redis_conn);
				$this->arr['server']->mysql_pool->put($mysql_conn);
				$this->arr['server']->send_user($this->arr['fd'],$return_arr);
				return true;
			}
			
			$user_prop = get_game_user_prop($uid,$mysql_conn,$redis_conn);//用户属性
			
			//工厂数据
			$factory_info = $GLOBALS["SYS_FACTORY_INFO"][$mf_id];
			if(!$factory_info){
				$return_arr["gd"]["msg"] = "获取数据出错";
				$this->arr['server']->redis_pool->put($redis_conn);
				$this->arr['server']->mysql_pool->put($mysql_conn);
				$this->arr['server']->send_user($this->arr['fd'],$return_arr);
				return true;
			}
			//用户工厂数据
			$user_factory = get_game_user_factory_info($uid,$mf_id,array(),$mysql_conn,$redis_conn);
			if(!$user_factory){
				$return_arr["gd"]["msg"] = "工厂没建造";
				$this->arr['server']->redis_pool->put($redis_conn);
				$this->arr['server']->mysql_pool->put($mysql_conn);
				$this->arr['server']->send_user($this->arr['fd'],$return_arr);
				return true;
			}
			//
			if($user_factory['open_seat_num']>=$user_factory['max_seat_num']){
				$return_arr["gd"]["msg"] = "生产队列已全部购买";
				$this->arr['server']->redis_pool->put($redis_conn);
				$this->arr['server']->mysql_pool->put($mysql_conn);
				$this->arr['server']->send_user($this->arr['fd'],$return_arr);
				return true;
			}
			
			if($user_factory['open_seat_num']!=$num){//购买队列
				$return_arr["gd"]["msg"] = "请先购买第".$user_factory['open_seat_num']."个队列";
				$this->arr['server']->redis_pool->put($redis_conn);
				$this->arr['server']->mysql_pool->put($mysql_conn);
				$this->arr['server']->send_user($this->arr['fd'],$return_arr);
				return true;
			}
			$buy_num = $num==1?'buy_num':'buy_num'.$num;
			$u_gold = $factory_info[$user_factory['grade']][$buy_num];
			if($user_prop['have_gold']<$u_gold){
				sys_log_write_content( '用户宝石:'.json_encode($user_prop).",所需宝石".$u_gold ,"error_log","member_have_gold_sql");
				$return_arr["gd"]["msg"] = "金币不足，无法购买！";
				$this->arr['server']->redis_pool->put($redis_conn);
				$this->arr['server']->mysql_pool->put($mysql_conn);
				$this->arr['server']->send_user($this->arr['fd'],$return_arr);
				return true;
			}
			
			$up_arr = array(
				'open_seat_num'	=> $user_factory['open_seat_num']+1	//已开放生产队列数量
			);
			$info = update_game_user_factory($uid,$mf_id,$up_arr,$mysql_conn,$redis_conn);
			if($info){
				
				//宝石扣除
				if($u_gold>0){
					$u_gold = $u_gold; //改变的宝石数
					$u_type = 2; //改变类型（1增加宝石，2减少宝石）
					$u_info = $factory_info[$user_factory['grade']]['name'].'工厂，购买队列'.$num.'扣除'; // 说明
					update_user_have_gold( $uid, $u_gold, $u_type, $u_info, $ip, $mysql_conn, $redis_conn );
				}	
				
				//获取工厂新的生产数据
				$new_user_factory = get_game_user_factory_info($uid,$mf_id,array(),$mysql_conn,$redis_conn);
				$return_arr = array(
					"ga"	=> 'factory_open_seat_num_bak',
					"code"	=> 1,
					"gd"	=> array(
						'mf_id'			=> $new_user_factory['mf_id'],//工厂ID
						'grade'			=> $new_user_factory['grade'],//工厂等级
						'open_seat_num'	=> $new_user_factory['open_seat_num'],//已经打开的栏位数量
						'msg'			=> '成功购买生产队列'
					)	
				);
			}else{
				$return_arr["gd"]["msg"] = "购买生产队列失败";
			}
			
			$this->arr['server']->redis_pool->put($redis_conn);
			$this->arr['server']->mysql_pool->put($mysql_conn);
			$this->arr['server']->send_user($this->arr['fd'],$return_arr);
			return true;
		}else{
			echo("用户不在线:fd=".$this->arr['fd']."||uid=".$tmp_user_info['uid']);
        }
        $this->arr['server']->redis_pool->put($redis_conn);
        $this->arr['server']->mysql_pool->put($mysql_conn);
        return true;
	}
	
	//工厂建造
	public function factory_create(){
		$return_arr = array(
			"ga"	=> 'game_txt_tip',
			"code"	=> 1,
			"gd"	=> array(
				'uid'=>0,
				'msg'=>"fail"
			)
		);
		
		$redis_conn = $this->arr['server']->redis_pool->get();
        $mysql_conn = $this->arr['server']->mysql_pool->get();
		$tmp_user_info = $this->arr['server']->get_user_by_fd($this->arr['fd']);
		if($tmp_user_info['uid']) {//如果用户登陆正常
			$uid = $tmp_user_info['uid'];
			
			$ip = $this->arr['ip'];
			$mf_id	= $this->arr['d']["mf_id"];	//工厂ID

			if( empty($mf_id) ){
				$return_arr["gd"]["msg"] = "数据不能为空";
				$this->arr['server']->redis_pool->put($redis_conn);
				$this->arr['server']->mysql_pool->put($mysql_conn);
				$this->arr['server']->send_user($this->arr['fd'],$return_arr);
				return true;
			}
			
			$user_prop = get_game_user_prop($uid,$mysql_conn,$redis_conn);//用户属性
			
			//工厂数据
			$factory_info = $GLOBALS["SYS_FACTORY_INFO"][$mf_id][1];
			if(!$factory_info){
				$return_arr["gd"]["msg"] = "获取数据出错";
				$this->arr['server']->redis_pool->put($redis_conn);
				$this->arr['server']->mysql_pool->put($mysql_conn);
				$this->arr['server']->send_user($this->arr['fd'],$return_arr);
				return true;
			}
			//用户工厂数据
			$user_factory = get_game_user_factory_info($uid,$mf_id,array(),$mysql_conn,$redis_conn);
			if($user_factory){
				$return_arr["gd"]["msg"] = "该工厂已建造";
				$this->arr['server']->redis_pool->put($redis_conn);
				$this->arr['server']->mysql_pool->put($mysql_conn);
				$this->arr['server']->send_user($this->arr['fd'],$return_arr);
				return true;
			}
			
			if($user_prop['grade']<$factory_info['grade2']){
				$return_arr["gd"]["msg"] = $factory_info['grade2']."级解锁";
				$this->arr['server']->redis_pool->put($redis_conn);
				$this->arr['server']->mysql_pool->put($mysql_conn);
				$this->arr['server']->send_user($this->arr['fd'],$return_arr);
				return true;
			}
			
			if($factory_info['exp']>0){
				if($user_prop['exp']<$factory_info['exp']){
					$return_arr["gd"]["msg"] = "经验不足";
					$this->arr['server']->redis_pool->put($redis_conn);
					$this->arr['server']->mysql_pool->put($mysql_conn);
					$this->arr['server']->send_user($this->arr['fd'],$return_arr);
					return true;
				}
			}
			
			if($factory_info['unlocknum']>0){
				if($user_prop['have_gold']<$factory_info['unlocknum']){
					sys_log_write_content( '用户宝石:'.json_encode($user_prop).",所需宝石".$factory_info['unlocknum'] ,"error_log","member_have_gold_sql");
					$return_arr["gd"]["msg"] = "金币不足，无法购买！";
					$this->arr['server']->redis_pool->put($redis_conn);
					$this->arr['server']->mysql_pool->put($mysql_conn);
					$this->arr['server']->send_user($this->arr['fd'],$return_arr);
					return true;
				}
			}
			
			$add_arr = array(
				'uid'	=> $uid,
				'mf_id'	=> $mf_id,
				'grade'	=> $factory_info['grade'],
				'open_seat_num'	=> $factory_info['act_num'],
				'max_seat_num'	=> $factory_info['all_num']
			);
			$info = add_member_factory($add_arr,$mysql_conn,$redis_conn);
			if($info){
				
				//宝石扣除
				if($factory_info['unlocknum']>0){
					$u_gold = $factory_info['unlocknum']; //改变的宝石数
					$u_type = 2; //改变类型（1增加宝石，2减少宝石）
					$u_info = $factory_info['name'].'工厂建造扣除'; // 说明
					update_user_have_gold( $uid, $u_gold, $u_type, $u_info, $ip, $mysql_conn, $redis_conn );
				}

				//经验值增加
				if($factory_info['exp2']>0){
					$exp_exp 	= $factory_info['exp2'];//改变的经验数
					$exp_info 	= $factory_info['name'].'工厂建造获得';//经验说明
					update_user_exp($uid,$exp_exp,$exp_info,$ip,$mysql_conn,$redis_conn);
				}				
				
				//添加用户工厂建造日志
				$add_arr = array(
					'uid'			=> $uid,
					'mf_id'			=> $mf_id,
					'type'			=> 2,
					'before_vip'	=> 0,	
					'after_vip' 	=> 1,	
					'exp'			=> 0,
					'gold'			=> $factory_info['unlocknum'],	
					'add_time'		=> date("Y-m-d H:i:s", time()),
					'info'			=> $factory_info['name'].'工厂建造'
				);
				add_member_factory_upgrade_log($add_arr,$mysql_conn,$redis_conn);
				
				//获取工厂新的生产数据
				$new_user_factory = get_game_user_factory_info($uid,$mf_id,array(),$mysql_conn,$redis_conn);
				$new_goods_info = get_factory_goods($uid,$new_user_factory,$mysql_conn,$redis_conn);//计算返回物品数据
				$return_arr = array(
					"ga"	=> 'factory_create_bak',
					"code"	=> 1,
					"gd"	=> array(
						'mf_id'			=> $new_user_factory['mf_id'],//工厂ID
						'grade'			=> $new_user_factory['grade'],//工厂等级
						'open_seat_num'	=> $new_user_factory['open_seat_num'],//已经打开的栏位数量
						'being_goods'	=> $new_goods_info['being_goods'],//正在生产中的物品
						'queue_goods'	=> $new_goods_info['queue_goods'],//等待生产的物品
						'succ_goods'	=> $new_goods_info['succ_goods'],//已经生产完成的物品
						'msg'			=> '成功建造'.$factory_info['name'].($factory_info['exp2']>0?('，经验+'.$factory_info['exp2']):'')
					)	
				);
			}else{
				$return_arr["gd"]["msg"] = "工厂建造失败";
			}
			
			$this->arr['server']->redis_pool->put($redis_conn);
			$this->arr['server']->mysql_pool->put($mysql_conn);
			$this->arr['server']->send_user($this->arr['fd'],$return_arr);
			return true;
		}else{
			echo("用户不在线:fd=".$this->arr['fd']."||uid=".$tmp_user_info['uid']);
        }
        $this->arr['server']->redis_pool->put($redis_conn);
        $this->arr['server']->mysql_pool->put($mysql_conn);
        return true;
	}
	
	//工厂升级
	public function factory_up_grade(){
		$return_arr = array(
			"ga"	=> 'game_txt_tip',
			"code"	=> 1,
			"gd"	=> array(
				'uid'=>0,
				'msg'=>"fail"
			)
		);
		
		$redis_conn = $this->arr['server']->redis_pool->get();
        $mysql_conn = $this->arr['server']->mysql_pool->get();
		$tmp_user_info = $this->arr['server']->get_user_by_fd($this->arr['fd']);
		if($tmp_user_info['uid']) {//如果用户登陆正常
			$uid = $tmp_user_info['uid'];
			
			$ip = $this->arr['ip'];
			$mf_id	= $this->arr['d']["mf_id"];	//工厂ID

			if( empty($mf_id) ){
				$return_arr["gd"]["msg"] = "数据不能为空";
				$this->arr['server']->redis_pool->put($redis_conn);
				$this->arr['server']->mysql_pool->put($mysql_conn);
				$this->arr['server']->send_user($this->arr['fd'],$return_arr);
				return true;
			}
			
			$user_prop = get_game_user_prop($uid,$mysql_conn,$redis_conn);//用户属性
			
			//工厂数据
			$factory_info = $GLOBALS["SYS_FACTORY_INFO"][$mf_id];
			if(!$factory_info){
				$return_arr["gd"]["msg"] = "获取数据出错";
				$this->arr['server']->redis_pool->put($redis_conn);
				$this->arr['server']->mysql_pool->put($mysql_conn);
				$this->arr['server']->send_user($this->arr['fd'],$return_arr);
				return true;
			}
			//用户工厂数据
			$user_factory = get_game_user_factory_info($uid,$mf_id,array(),$mysql_conn,$redis_conn);
			if(!$user_factory){
				$return_arr["gd"]["msg"] = "工厂没建造";
				$this->arr['server']->redis_pool->put($redis_conn);
				$this->arr['server']->mysql_pool->put($mysql_conn);
				$this->arr['server']->send_user($this->arr['fd'],$return_arr);
				return true;
			}
			
			if($user_factory['grade']>=count($factory_info)){
				$return_arr["gd"]["msg"] = "工厂已达到最高等级";
				$this->arr['server']->redis_pool->put($redis_conn);
				$this->arr['server']->mysql_pool->put($mysql_conn);
				$this->arr['server']->send_user($this->arr['fd'],$return_arr);
				return true;
			}
			
			//新工厂等级数据
			$tmp_factory_info = $factory_info[$user_factory['grade']+1];
			
			if($tmp_factory_info['exp']>0){
				if($user_prop['exp']<$tmp_factory_info['exp']){
					$return_arr["gd"]["msg"] = "经验不足";
					$this->arr['server']->redis_pool->put($redis_conn);
					$this->arr['server']->mysql_pool->put($mysql_conn);
					$this->arr['server']->send_user($this->arr['fd'],$return_arr);
					return true;
				}
			}
			
			if($tmp_factory_info['num2']>0){
				if($user_prop['have_gold']<$tmp_factory_info['num2']){
					sys_log_write_content( '用户宝石:'.json_encode($user_prop).",所需宝石".$tmp_factory_info['num2'] ,"error_log","member_have_gold_sql");
					$return_arr["gd"]["msg"] = "金币不足！";
					$this->arr['server']->redis_pool->put($redis_conn);
					$this->arr['server']->mysql_pool->put($mysql_conn);
					$this->arr['server']->send_user($this->arr['fd'],$return_arr);
					return true;
				}
			}
			
			$up_arr = array(
				'grade'			=> $user_factory['grade']+1,	//已完成生产数量
				'max_seat_num'	=> $tmp_factory_info['all_num']	//最大生产位数量
			);
			$info = update_game_user_factory($uid,$mf_id,$up_arr,$mysql_conn,$redis_conn);
			if($info){
				
				//宝石扣除
				if($tmp_factory_info['num2']>0){
					$u_gold = $tmp_factory_info['num2']; //改变的宝石数
					$u_type = 2; //改变类型（1增加宝石，2减少宝石）
					$u_info = $tmp_factory_info['name'].'工厂升级扣除'; // 说明
					update_user_have_gold( $uid, $u_gold, $u_type, $u_info, $ip, $mysql_conn, $redis_conn );
				}

				//经验值增加
				if($tmp_factory_info['exp2']>0){
					$exp_exp 	= $tmp_factory_info['exp2'];//改变的经验数
					$exp_info 	= $tmp_factory_info['name'].'工厂升级获得';//经验说明
					update_user_exp($uid,$exp_exp,$exp_info,$ip,$mysql_conn,$redis_conn);
				}				
				
				//添加用户工厂升级日志
				$add_arr = array(
					'uid'			=> $uid,
					'mf_id'			=> $mf_id,
					'type'			=> 1,
					'before_vip'	=> $user_factory['grade'],	
					'after_vip' 	=> $user_factory['grade']+1,	
					'exp'			=> 0,
					'gold'			=> $tmp_factory_info['num2'],	
					'add_time'		=> date("Y-m-d H:i:s", time()),
					'info'			=> $tmp_factory_info['name'].'工厂升级'
				);
				add_member_factory_upgrade_log($add_arr,$mysql_conn,$redis_conn);
				
				//获取工厂新的生产数据
				$new_user_factory = get_game_user_factory_info($uid,$mf_id,array(),$mysql_conn,$redis_conn);
				$new_goods_info = get_factory_goods($uid,$new_user_factory,$mysql_conn,$redis_conn);//计算返回物品数据
				$return_arr = array(
					"ga"	=> 'factory_up_grade_bak',
					"code"	=> 1,
					"gd"	=> array(
						'mf_id'			=> $new_user_factory['mf_id'],//工厂ID
						'grade'			=> $new_user_factory['grade'],//工厂等级
						'open_seat_num'	=> $new_user_factory['open_seat_num'],//已经打开的栏位数量
						'being_goods'	=> $new_goods_info['being_goods'],//正在生产中的物品
						'queue_goods'	=> $new_goods_info['queue_goods'],//等待生产的物品
						'succ_goods'	=> $new_goods_info['succ_goods'],//已经生产完成的物品
						'msg'			=> '工厂升级成功'
					)	
				);
			}else{
				$return_arr["gd"]["msg"] = "升级工厂失败";
			}
			
			$this->arr['server']->redis_pool->put($redis_conn);
			$this->arr['server']->mysql_pool->put($mysql_conn);
			$this->arr['server']->send_user($this->arr['fd'],$return_arr);
			return true;
		}else{
			echo("用户不在线:fd=".$this->arr['fd']."||uid=".$tmp_user_info['uid']);
        }
        $this->arr['server']->redis_pool->put($redis_conn);
        $this->arr['server']->mysql_pool->put($mysql_conn);
        return true;
	}
		
	// 工厂生产产品完成收取物品入仓库
    public function factory_good_save(){
		$return_arr = array(
			"ga"	=> 'game_txt_tip',
			"code"	=> 1,
			"gd"	=> array(
				'uid'=>0,
				'msg'=>"fail"
			)
		);
		
		$redis_conn = $this->arr['server']->redis_pool->get();
        $mysql_conn = $this->arr['server']->mysql_pool->get();
		$tmp_user_info = $this->arr['server']->get_user_by_fd($this->arr['fd']);
		if($tmp_user_info['uid']) {//如果用户登陆正常
			$uid = $tmp_user_info['uid'];
			
			$ip = $this->arr['ip'];
			$mf_id	= $this->arr['d']["mf_id"];	//工厂ID
			if( empty($mf_id) ){
				$return_arr["gd"]["msg"] = "数据不能为空";
				$this->arr['server']->redis_pool->put($redis_conn);
				$this->arr['server']->mysql_pool->put($mysql_conn);
				$this->arr['server']->send_user($this->arr['fd'],$return_arr);
				return true;
			}
			
			$user_prop = get_game_user_prop($uid,$mysql_conn,$redis_conn);//用户属性
			
			//工厂数据
			$factory_info = $GLOBALS["SYS_FACTORY_INFO"][$mf_id];
			if(!$factory_info){
				$return_arr["gd"]["msg"] = "获取数据出错";
				$this->arr['server']->redis_pool->put($redis_conn);
				$this->arr['server']->mysql_pool->put($mysql_conn);
				$this->arr['server']->send_user($this->arr['fd'],$return_arr);
				return true;
			}
			//用户工厂数据
			$user_factory = get_game_user_factory_info($uid,$mf_id,array(),$mysql_conn,$redis_conn);
			if(!$user_factory){
				$return_arr["gd"]["msg"] = "工厂没建造";
				$this->arr['server']->redis_pool->put($redis_conn);
				$this->arr['server']->mysql_pool->put($mysql_conn);
				$this->arr['server']->send_user($this->arr['fd'],$return_arr);
				return true;
			}
			$succ_goods = $user_factory['succ_goods']?json_decode($user_factory['succ_goods'],true):'';
			$succ_goods_tol = $succ_goods?count($succ_goods):0;
			if( $succ_goods_tol<1 ){
				$return_arr["gd"]["msg"] = "没有已完成的物品";
				$this->arr['server']->redis_pool->put($redis_conn);
				$this->arr['server']->mysql_pool->put($mysql_conn);
				$this->arr['server']->send_user($this->arr['fd'],$return_arr);
				return true;
			}
			
			//检测仓库
			foreach($succ_goods as $k=>$v){	
				$is_goods_arr[] =  array(
					'good_id'	=> $v['id'],
					'num'		=> $v['n']?$v['n']:1
				);
			}
			$is_store = is_check_store($uid,$is_goods_arr,$mysql_conn,$redis_conn);
			if(!$is_store){
				$return_arr["gd"]["msg"] = "仓库空间不足";
				$this->arr['server']->redis_pool->put($redis_conn);
				$this->arr['server']->mysql_pool->put($mysql_conn);
				$this->arr['server']->send_user($this->arr['fd'],$return_arr);
				return true;
			}
			
			$up_arr = array(
				'goods_num'		=> $user_factory['goods_num']+count($succ_goods),	//已完成生产数量
				'succ_goods'	=> ''	//置空已完成生产的物品数据
			);
			$info = update_game_user_factory($uid,$mf_id,$up_arr,$mysql_conn,$redis_conn);
			if($info){
				
				//循环
				if($succ_goods){
					foreach($succ_goods as $k=>$v){
						//入仓库
						$goods_arr =  array(
							'good_id'	=> $v['id'],
							'num'		=> $v['n']?$v['n']:1
						);
						store_good_data_save($uid,$goods_arr,$ip,$mysql_conn,$redis_conn);
						
						//更新用户完成工厂商品总数
						$num_arr = array(
							'goods_num'	=> 'goods_num+'.($v['n']?$v['n']:1),	//制造的商品总数
							'up_time'	=> date("Y-m-d H:i:s",time())	//数据更新时间
						);
						update_game_num($uid,$num_arr,$mysql_conn,$redis_conn);
						
						//日志
						$factory_goods = $GLOBALS["SYS_FACTORY_GOOD"][$mf_id][$v['id']];
						$add_arr = array(
							'uid'		=> $uid,
							'mf_id'		=> $mf_id,
							'mf_vip'	=> $user_factory['grade'],
							'num'		=> $v['n']?$v['n']:1,
							'goods_num'	=> $v['id'],
							'add_time'	=> date("Y-m-d H:i:s",time()),
							'info'		=> $factory_goods['name'].'收获'
						);
						add_member_factory_reward_log($add_arr,$mysql_conn,$redis_conn);
					}
				}
				
				//获取工厂新的生产数据
				$new_user_factory = get_game_user_factory_info($uid,$mf_id,array(),$mysql_conn,$redis_conn);
				$new_goods_info = get_factory_goods($uid,$new_user_factory,$mysql_conn,$redis_conn);//计算返回物品数据
				$return_arr = array(
					"ga"	=> 'factory_good_save_bak',
					"code"	=> 1,
					"gd"	=> array(
						'mf_id'			=> $new_user_factory['mf_id'],//工厂ID
						'grade'			=> $new_user_factory['grade'],//工厂等级
						'open_seat_num'	=> $new_user_factory['open_seat_num'],//已经打开的栏位数量
						'being_goods'	=> $new_goods_info['being_goods'],//正在生产中的物品
						'queue_goods'	=> $new_goods_info['queue_goods'],//等待生产的物品
						'succ_goods'	=> $new_goods_info['succ_goods'],//已经生产完成的物品
						'msg'			=> '收取物品成功'
					)	
				);
			}else{
				$return_arr["gd"]["msg"] = "收取物品失败";
			}
			
			$this->arr['server']->redis_pool->put($redis_conn);
			$this->arr['server']->mysql_pool->put($mysql_conn);
			$this->arr['server']->send_user($this->arr['fd'],$return_arr);
			return true;
		}else{
			echo("用户不在线:fd=".$this->arr['fd']."||uid=".$tmp_user_info['uid']);
        }
        $this->arr['server']->redis_pool->put($redis_conn);
        $this->arr['server']->mysql_pool->put($mysql_conn);
        return true;
    }




}