<?php
/**存到redis里的数据
 * Created by 252378189.
 * User: ddcai
 * Date: 2018/11/16
 * Time: 9:59
 */

//==========begin 基本数据定义
//玩家登陆数据（存在redis里）
$DATA_USER_INFO = array(
    'uid'=>'',//用户ＩＤ
    'name'=>'',//用户帐号
    'uname'=>'',//用户呢称
    'sex'=>'',//用户性别
    'pic'=>'',//用户头像
    'ip'=>'',//用户登陆IP
    'time'=>'',//登陆时间
    'fd'=>'',//用户长连接ＩＤ
    'ws'=>''//长连接地址
);

//玩家连接数据fd=>uid(存在内存里)
$USER_LIST_FD_UID = array(
    "连接的fd值"	=>array('uid'=>'用户的uid值')
);
//玩家连接数据uid=>fd(存在内存里)
$USER_LIST_UID_FD = array(
    "用户的uid"	=>array('fd'=>'连接的fd值')
);


//==========end 基本数据定义

//begin 服务端http方式请求游戏服务websocket接口的协议定义
//=================http方的数据格式
$TMP_HTTP_REQUEST_DATA = array(
    'uid'=>"",//http请求的用户UID,
    'do_a'=>"",//http要执行的动作(在ajax_user_msg.class.php里制定的动作),
    'a'=>"",//需要执行的websocket端动作
    'm'=>"",//需要执行的websocket端模块,
    'd'=>"",//websocket端执行时自动提交的数据参数(数组)
    't'=>"",//生成消息的时间,
);

//如果执行失败返回:false
//如果执行成功返回:返回执行 m 模块执行完了 a 动作之后的结果

//数据请求例子：
$TMP_HTTP_REQUEST_DATA = set_login_token($TMP_HTTP_REQUEST_DATA);
$re = post_request("http://游戏websocket地址:监听端口/", "token=" . $TMP_HTTP_REQUEST_DATA);
var_dump($re);

//end 服务端http方式请求游戏服务websocket接口的协议定义


//==begin 异步执行队列数据结构
//SYS_INFO_LIST 为 redis的list
//每项数据的结构为：
/*
SYS_INFO_LIST[0] = array(
    'uid'=>"",//请求的用户UID,
    'a'=>"",//需要执行的websocket端动作
    'm'=>"",//需要执行的websocket端模块,
    'd'=>"",//websocket端执行时自动提交的数据参数(数组)
    't'=>"",//要执行消息的时间,
);
 */
//==end 异步执行队列数据结构


//=========begin 游戏请求===================
//用户初始登登请求
/*
1、客户端判断是否有存有用户的唯一KEY值，
2、如果有就把这个唯一的KEY值传给服务器，
3、如果没有，则生成一个key值传给服务器。
 */
$HTTP_LOGIN_SEND = array(
    "a"=>"login",
    "m"=>"init",
    "d"=>array(
        "code"=>"",//登录时获取的 code(这个就是客户端保存或生成的key)
        "tid"=>"",//第三方登录id  微信
        "reid"=>"",//推荐人
        "sid"=>"",//渠道
        "sid2"=>"",//渠道2
        "sys"=>""//操作系统
    ),
    "code"=>1
);

//登录成功返回的信息
$HTTP_LOGIN_SEND_RETURN = array(
    "ga"	=> 'http_login_bak',
    "code"	=> 1,
    "gd"	=> array(
        'info' => array(
            'sid'       => "渠道",
            'sid2'      => "渠道2",
            'uid' 		=> "UID",
            'name' 		=> "帐号",
            'nickname' 	=> "呢称",
            'pic' 		=> "头像",
            'sex' 		=> "性别",
            'time'      => "登陆时间",//
            'token'     => "登陆token"
        ),
        'ws' => array(
            'ws' 	=> "长连接地址",
            'time' 	=> "长连接时间"
        )
    )
);
//登陆失败
//登录返回的信息
$HTTP_LOGIN_SEND_RETURN_ERROR = array(
    'ga'		=> 'http_error_bak',
    "code"	=> 2,//1成功，2失败,3停服维护
    "msg"	=> '登陆失败' //登陆信息提示
);


//=========end 游戏请求===================

//=========begin　长连接成功后，处理用户的长连接登陆
//长连接建立成功之后，应该给服务器发送正式的登陆请求：
$return_LOGIN_SEND = array(
    "a"=>"login",
    "m"=>"user_login",
    "d"=>array(
        'token_key'=>$return_LOGIN['token_key']
    ),
    "code"=>1
);
//登陆成功返回用户的信息：
$return_LOGIN_RETURN = array(
    "ga"=>"login",
    "gd"=>array(
        "uid"		=> $tmp_data_online['uid'],//用户ID,
        "name"		=> $tmp_data_online['name'],//"用户帐号",
        "nickname"     => $tmp_data_online['uname'],//用户呢称
        "pic"       => $tmp_data_online['pic'],//"用户头像",
        "sex"       => $tmp_data_online['sex'],//"用户性别",
        "ip"        => $tmp_data_online['ip'],//客户端IP
    ),
    "code"=>1
);
//登陆失败，返回
$return_LOGIN_RETURN = array(
    "ga"=>"login_error",
    "gd"=>array(
        'uid'=>0,
        'msg'=>"登陆失败！！"
    ),
    "code"=>1
);
//=========end　长连接成功后，处理用户的长连接登陆


/*========= 玩家基本数据 begin =========*/
$http_init_info = array(
    "a"=>"init_info",
    "m"=>"init",
    "d"=>array(),
	"token"=>'token',
    "code"=>1
);
//成功返回的信息：
$return_init_info = array(
    "ga"=>"init_info",
    "gd"=>array(
		'have_gold'=>'可用金币',
		'grade'=>'等级',
		'exp'=>'当前等级经验',
		'upgrade_exp'=>'升级经验'
    ),
    "code"=>1
);
//失败，返回
$return_init_info = array(
    "ga"=>"init_info_error",
    "gd"=>array(
        'uid'=>0,
        'msg'=>"获取失败！！"
    ),
    "code"=>1
);
/*========= 玩家基本数据 end =========*/


/*========= 玩家花田数据 begin =========*/
$http_init_field = array(
    "a"=>"init_field",
    "m"=>"init",
    "d"=>array(),
	"token"=>'token',
    "code"=>1
);
//成功返回的信息：
$return_init_field = array(
    "ga"=>"init_field",
    "gd"=>array(
		array(
			
			'ff_id'=>'花田编号',
			'max_grade'=>'花田的最高等级',//花田的最高等级
			'ff_vip'=>'花田等级',//1未开锁，2等级一，3等级二，4等级三
			'ff_exp'=>'花田当前的经验值',
			'seed'=>'花田生长加速百分比',
			'is_lock'=>'是否可以解锁花田',//1是2否
			'next_seed'=>'下一级花田生长加速百分比',
			'next_exp'=>'花田的升下一级经验值',
			'ff_id_unlocknum'=>'解锁所需金币',
			'next_ff_id_glod'=>'下一级升级所需金币',
			'pic'=>"huatianlv1",//'花田正常图片',
			'ain'=>"",//'花田正常动画',
			'fat_time'=>'当前施肥时间',
			'fat_time_tol'=>'施肥总时间',
			
			'seed_data'=>array(//花卉数据
				'grow_time_tol'=>'生长总时间',
				'mature_time'=>'距离成熟时间',
				'next_mature_time'=>'当前阶段成长时间',
				'grow_static'=>'当前生长状态',//1发芽期、2生长期、3花苞期、4成熟期
				'water_time'	=> '可以浇水时间', //
				'is_water'	=> '是否可以浇水', //是否可以浇水 1是2否
				'id'=>"hh01",//'花卉ID',
				'name'=>"红玫瑰",//'花卉名称',
				'grade'=>"1",//'花卉等级',
				'pic'=>"hmgseed",//'当前花卉图片',
				'ain'=>"",//'当前花卉动画',
			)
		),
		
    ),
    "code"=>1
);
//失败，返回
$return_init_field = array(
    "ga"=>"game_fail_tip",
    "gd"=>array(
        'uid'=>0,
        'msg'=>"获取失败！！"
    ),
    "code"=>1
);
/*========= 玩家花田数据 end =========*/

/*========= 花卉种子数据 begin =========*/
$http_init_seed_list = array(
    "a"=>"init_seed_list",
    "m"=>"init",
    "d"=>array(),
	"token"=>'token',
    "code"=>1
);
//成功返回的信息：
$return_init_seed_list = array(
    "ga"=>"init_seed_list",
    "gd"=>array(
		"seed_data"=>array(
			array(
				'id'=>"hh01",//'花卉ID',
				'name'=>"红玫瑰",//'花卉名称',
				'grade'=>"1",//'花卉等级',
				'grade2'=>"1",//'要求用户最底等级',
				'grade3'=>"100",//'要求用户最高等级',
				'gold'=>"100",//'种子价格',
				'pic'=>"",//'花卉种子图片',
				'ain'=>"",//'花卉种子动画',
			),
		),
		"fat_data"=>array(
			array(
				"id"=>'施肥id',
				"pic"=>'施肥图片',
				"ain"=>'施肥动画',
				"num"=>'施肥价格'
			)
		)
		
    ),
    "code"=>1
);
//失败，返回
$return_init_seed_list = array(
    "ga"=>"game_fail_tip",
    "gd"=>array(
        'uid'=>0,
        'msg'=>"获取失败！！"
    ),
    "code"=>1
);
/*========= 花卉种子数据 end =========*/

/*========= 花田升级解锁数据 begin =========*/
$http_init_flower_grade = array(
    "a"=>"init_flower_grade",
    "m"=>"init",
    "d"=>array(
		'ff_id'=>'花田编号',
		'type'=>" 类型"//1升级 2解锁
    ),
	"token"=>'token',
    "code"=>1
);
//成功返回的信息：
$return_init_flower_grade = array(
    "ga"=>"init_flower_grade",
    "gd"=>array(
		
		'type'=>'类型',
		'ff_id'=>'花田编号',
		'ff_vip'=>'花田等级',//1未开锁，2等级一，3等级二，4等级三
		'ff_exp'=>'花田当前的经验值',
		'seed'=>'花田生长加速百分比',
		'next_ht_lock'=>'可以解锁的下一块花田id',//
		'next_seed'=>'下一级花田生长加速百分比',
		'max_grade'=>'花田的最高等级',
		'next_exp'=>'花田的升下一级经验值',
		'ff_id_unlocknum'=>'解锁所需金币',
		'next_ff_id_glod'=>'下一级升级所需金币',
		'pic'=>"huatianlv1",//'花田正常图片',
		'ain'=>"",//'花田正常动画',
		
        'msg'=>'升级/解锁成功'
    ),
    "code"=>1
);
//失败，返回
$return_init_flower_grade = array(
    "ga"=>"game_fail_tip",
    "gd"=>array(
        'uid'=>0,
        'msg'=>"升级/解锁失败！！"
    ),
    "code"=>1
);
/*========= 花田升级解锁数据 end =========*/

/*========= 花卉种植数据 begin =========*/
$http_init_plant_flower = array(
    "a"=>"init_plant_flower",
    "m"=>"init",
    "d"=>array(
		'ff_id'=>'花田编号',
		'seed_num'=>"花卉编号"
    ),
	"token"=>'token',
    "code"=>1
);
//成功返回的信息：
$return_init_plant_flower = array(
    "ga"=>"init_plant_flower",
    "gd"=>array(
		
		'ff_id'=>'花田id',
		'fat_time'=>'当前施肥时间',
		'fat_time_tol'=>'施肥总时间',
		'ff_exp'=>'花田当前的经验值',
		'seed_data'=>array(//花卉数据
			'grow_time_tol'=>'生长总时间',
			'mature_time'=>'距离成熟时间',
			'next_mature_time'=>'当前阶段成长时间',
			'grow_static'=>'当前生长状态',//1发芽期、2生长期、3花苞期、4成熟期
			'water_time'	=> '可以浇水时间', //
			'is_water'	=> '是否可以浇水', //是否可以浇水 1是2否
			'id'=>"hh01",//'花卉ID',
			'name'=>"红玫瑰",//'花卉名称',
			'grade'=>"1",//'花卉等级',
			'pic'=>"hmgseed",//'当前花卉图片',
			'ain'=>"",//'当前花卉动画',
		),
        'msg'=>'种植成功'
    ),
    "code"=>1
);
//失败，返回
$return_init_plant_flower = array(
    "ga"=>"game_fail_tip",
    "gd"=>array(
        'uid'=>0,
        'msg'=>"种植失败！！"
    ),
    "code"=>1
);
/*========= 花卉种植数据 end =========*/

/*========= 花卉成长数据 begin =========*/
$http_init_grow_flower = array(
    "a"=>"init_grow_flower",
    "m"=>"init",
    "d"=>array(
		'ff_id'=>'花田编号',
    ),
	"token"=>'token',
    "code"=>1
);
//成功返回的信息：
$return_init_grow_flower = array(
    "ga"=>"init_grow_flower",
    "gd"=>array(
		
		'ff_id'=>'花田id',
		'fat_time'=>'当前施肥时间',
		'fat_time_tol'=>'施肥总时间',
		'ff_exp'=>'花田当前的经验值',
		'seed_data'=>array(//花卉数据
			'grow_time_tol'=>'生长总时间',
			'mature_time'=>'当前成熟时间',
			'next_mature_time'=>'下一阶段成长时间',
			'grow_static'=>'当前生长状态',//1发芽期、2生长期、3花苞期、4成熟期
			'water_time'	=> '可以浇水时间', //
			'is_water'	=> '是否可以浇水', //是否可以浇水 1是2否
			'id'=>"hh01",//'花卉ID',
			'name'=>"红玫瑰",//'花卉名称',
			'grade'=>"1",//'花卉等级',
			'pic'=>"hmgseed",//'当前花卉图片',
			'ain'=>"",//'当前花卉动画',
		),
        'msg'=>'成长成功'
    ),
    "code"=>1
);
//失败，返回
$return_init_growt_flower = array(
    "ga"=>"game_fail_tip",
    "gd"=>array(
        'uid'=>0,
        'msg'=>"成长失败！！"
    ),
    "code"=>1
);
/*========= 花卉成长数据 end =========*/

/*========= 花卉浇水数据 begin =========*/
$http_init_flower_water = array(
    "a"=>"init_flower_water",
    "m"=>"init",
    "d"=>array(
		'ff_id'=>'花田编号',
		'f_uid'=>'好友id',
    ),
	"token"=>'token',
    "code"=>1
);
//成功返回的信息：
$return_init_flower_water = array(
    "ga"=>"init_flower_water",
    "gd"=>array(
		
		'ff_id'=>'花田id',
		'fat_time'=>'当前施肥时间',
		'fat_time_tol'=>'施肥总时间',
		'ff_exp'=>'花田当前的经验值',
		'seed_data'=>array(//花卉数据
			'grow_time_tol'=>'生长总时间',
			'mature_time'=>'当前成熟时间',
			'next_mature_time'=>'下一阶段成长时间',
			'grow_static'=>'当前生长状态',//1发芽期、2生长期、3花苞期、4成熟期
			'water_time'	=> '可以浇水时间', //
			'is_water'	=> '是否可以浇水', //是否可以浇水 1是2否
			'id'=>"hh01",//'花卉ID',
			'name'=>"红玫瑰",//'花卉名称',
			'grade'=>"1",//'花卉等级',
			'pic'=>"hmgseed",//'当前花卉图片',
			'ain'=>"",//'当前花卉动画',
		),
		'exp_data'=>array(
			'exp'=>"20",//'增加花田经验数',
			'exp2'=>"2",//'增加玩家经验数',
			't'=>"7200",//'浇水有效时长'
		),
        'msg'=>'浇水成功'
    ),
    "code"=>1
);
//失败，返回
$return_init_flower_water = array(
    "ga"=>"game_fail_tip",
    "gd"=>array(
        'uid'=>0,
        'msg'=>"浇水失败！！"
    ),
    "code"=>1
);
/*========= 花卉浇水数据 end =========*/

/*========= 花卉施肥数据 begin =========*/
$http_init_flower_fertilize = array(
    "a"=>"init_flower_fertilize",
    "m"=>"init",
    "d"=>array(
		'ff_id'=>'花田编号',
		'f_uid'=>'好友id',
    ),
	"token"=>'token',
    "code"=>1
);
//成功返回的信息：
$return_init_flower_fertilize = array(
    "ga"=>"init_flower_fertilize",
    "gd"=>array(
		
		'ff_id'=>'花田id',
		'fat_time'=>'当前施肥时间',
		'fat_time_tol'=>'施肥总时间',
		'ff_exp'=>'花田当前的经验值',
		'seed_data'=>array(//花卉数据
			'grow_time_tol'=>'生长总时间',
			'mature_time'=>'当前成熟时间',
			'next_mature_time'=>'下一阶段成长时间',
			'grow_static'=>'当前生长状态',//1发芽期、2生长期、3花苞期、4成熟期
			'water_time'	=> '可以浇水时间', //
			'is_water'	=> '是否可以浇水', //是否可以浇水 1是2否
			'id'=>"hh01",//'花卉ID',
			'name'=>"红玫瑰",//'花卉名称',
			'grade'=>"1",//'花卉等级',
			'pic'=>"hmgseed",//'当前花卉图片',
			'ain'=>"",//'当前花卉动画',
		),
		'exp_data'=>array(
			'exp'=>"20",//'增加花田经验数',
			'exp2'=>"2",//'增加玩家经验数',
			't'=>"7200",//'施肥有效时长'
		),
        'msg'=>'施肥成功'
    ),
    "code"=>1
);
//失败，返回
$return_init_flower_fertilize = array(
    "ga"=>"game_fail_tip",
    "gd"=>array(
        'uid'=>0,
        'msg'=>"施肥失败！！"
    ),
    "code"=>1
);
/*========= 花卉施肥数据 end =========*/

/*========= 花田施肥失效数据 begin =========*/
$http_init_flower_fat = array(
    "a"=>"init_flower_fat",
    "m"=>"init",
    "d"=>array(
		'ff_id'=>'花田编号',
    ),
	"token"=>'token',
    "code"=>1
);
//成功返回的信息：
$return_init_flower_fat = array(
    "ga"=>"init_flower_fat",
    "gd"=>array(
		'ff_id'=>'花田id',
		'fat_time'=>'当前施肥时间',
		'fat_time_tol'=>'施肥总时间',
		'ff_exp'=>'花田当前的经验值',
		'seed_data'=>array(//花卉数据
			'grow_time_tol'=>'生长总时间',
			'mature_time'=>'距离成熟时间',
			'next_mature_time'=>'本阶段成长时间',
			'grow_static'=>'当前生长状态',//1发芽期、2生长期、3花苞期、4成熟期
			'water_time'	=> '可以浇水倒计时间', //
			'is_water'	=> '是否可以浇水', //是否可以浇水 1是2否
			'id'=>"hh01",//'花卉ID',
			'name'=>"红玫瑰",//'花卉名称',
			'grade'=>"1",//'花卉等级',
			'pic'=>"hmgseed",//'当前花卉图片',
			'ain'=>"",//'当前花卉动画',
		),
        'msg'=>'成长成功'
    ),
    "code"=>1
);
//失败，返回
$return_init_flower_fertilize = array(
    "ga"=>"game_fail_tip",
    "gd"=>array(
        'uid'=>0,
        'msg'=>"请求失败！！"
    ),
    "code"=>1
);
/*========= 花田施肥失效数据 end =========*/

/*========= 花卉收获数据 begin =========*/
$http_init_collect_flower = array(
    "a"=>"init_collect_flower",
    "m"=>"init",
    "d"=>array(
		'ff_id'=>'花田编号',
    ),
	"token"=>'token',
    "code"=>1
);
//成功返回的信息：
$return_init_collect_flower = array(
    "ga"=>"init_collect_flower",
    "gd"=>array(
		
		'ff_id'=>'花田id',
		'fat_time'=>'当前施肥时间',
		'fat_time_tol'=>'施肥总时间',
		'ff_exp'=>'花田当前的经验值',
		'seed_data'=>array(//花卉数据
			'grow_time_tol'=>'生长总时间',
			'mature_time'=>'当前成熟时间',
			'next_mature_time'=>'下一阶段成长时间',
			'grow_static'=>'当前生长状态',//1发芽期、2生长期、3花苞期、4成熟期
			'water_time'	=> '可以浇水时间', //
			'is_water'	=> '是否可以浇水', //是否可以浇水 1是2否
			'id'=>"hh01",//'花卉ID',
			'name'=>"红玫瑰",//'花卉名称',
			'grade'=>"1",//'花卉等级',
			'pic'=>"hmgseed",//'当前花卉图片',
			'ain'=>"",//'当前花卉动画',
		),
		'exp_data'=>array(
			'exp'	=> $seed_data['exp'],//'增加花田经验数',
			'exp2'	=> $seed_data['exp2'],//'增加玩家经验数',
			't'		=> 0 //'有效时长'
		),
		
        'msg'=>'收获成功'
    ),
    "code"=>1
);
//失败，返回
$return_init_collect_flower = array(
    "ga"=>"game_fail_tip",
    "gd"=>array(
        'uid'=>0,
        'msg'=>"收获失败！！"
    ),
    "code"=>1
);
/*========= 花卉收获数据 end =========*/




//=======================begin 工厂相关协议===================
//=======================工厂相关协议===================
//=======================工厂相关协议===================
//=======================工厂相关协议===================
//特别说明：
//$http_开头的请求表示用http的方式请求数据，
//$socket_开头的方式表示用websocket的方式获取数据

/*=========== 获取玩家某些物品数量的协议 begin ==========*/
$http_send_good = array(
    "a"=>"send_good",
    "m"=>"init",
    "d"=>array(
        "good_id"=>array(
            '物品ID',
            '物品ID2',
        )
    ),
    "code"=>1
);
//成功返回的信息：
$return_send_good = array(
    "ga"=>"send_good_bak",
    "gd"=>array(
        '物品id'=>array(
            'id'=>'物品ID',
            'num'=>'总数量'
        ),
        '物品id2'=>array(
            'id'=>'物品ID',
            'num'=>'总数量'
        )
    ),
    "code"=>1
);

/*=========== 获取玩家某些物品数量的协议 end ==========*/

/*=========== 工厂初始化协议 begin ==========*/
$http_send_factory = array(
    "a"=>"send_factory",
    "m"=>"init",
    "d"=>array(),
    "code"=>1
);
//成功返回的信息：
$return_send_factory = array(
    "ga"=>"send_factory_bak",
    "gd"=>array(
        '工厂id'=>array(
            'mf_id'=>'工厂ID',
            'grade'=>'工厂等级',
            'open_seat_num'=>'已经打开的栏位数量',
            'being_goods'=>array(//正在生产中的物品
                'id'=>'生产物品的ID',
                't'=>'还有多少秒生产完成'
            ),
            'queue_goods'=>array(//等待生产的物品
                array(
                    'id'=>'生产物品的ID',
                    't'=>'还有多少秒开始生产',
                    't2'=>'还有多少秒生产完成'
                )
            ),
            'succ_goods'=>array(//已经生产完成的物品
                array(
                    'id'=>'生产物品的ID',
                    't'=>'开始生产时间',
                    't2'=>'生产完成时间',
                    'n'=>'物品个数'
                )
            )
        )
    ),
    "code"=>1
);

/*=========== 工厂初始化协议 end ==========*/


/*=========== 工厂生产产品协议 begin ==========*/
$socket_factory_act = array(
    "a"=>"factory_act",
    "m"=>"gzhq_factory",
    "d"=>array(
        'mf_id'=>'工厂ID',
        'id'=>'要生产的物品ID'
    ),
    "code"=>1
);
//成功返回的信息：
$return_send_factory_act = array(
    "ga"=>"factory_act_bak",
    "gd"=>array(
        'mf_id'=>'工厂ID',
        'grade'=>'工厂等级',
        'open_seat_num'=>'已经打开的栏位数量',
        'being_goods'=>array(//正在生产中的物品
            'id'=>'生产物品的ID',
            't'=>'还有多少秒生产完成'
        ),
        'queue_goods'=>array(//等待生产的物品
            array(
                'id'=>'生产物品的ID',
                't'=>'还有多少秒开始生产',
                't2'=>'还有多少秒生产完成'
            )
        ),
        'succ_goods'=>array(//已经生产完成的物品
            array(
                'id'=>'生产物品的ID',
                't'=>'开始生产时间',
                't2'=>'生产完成时间',
                'n'=>'物品个数'
            )
        )
    ),
    "code"=>1
);

/*=========== 工厂生产产品协议 end ==========*/

/*=========== 工厂生产产品完成的协议 begin ==========*/
$socket_factory_good_get = array(
    "a"=>"factory_good_get",
    "m"=>"gzhq_factory",
    "d"=>array(
        'mf_id'=>'工厂ID'
    ),
    "code"=>1
);
//成功返回的信息：
$return_send_factory_act = array(
    "ga"=>"factory_good_get_bak",
    "gd"=>array(
        'mf_id'=>'工厂ID',
        'grade'=>'工厂等级',
        'open_seat_num'=>'已经打开的栏位数量',
        'being_goods'=>array(//正在生产中的物品
            'id'=>'生产物品的ID',
            't'=>'还有多少秒生产完成'
        ),
        'queue_goods'=>array(//等待生产的物品
            array(
                'id'=>'生产物品的ID',
                't'=>'还有多少秒开始生产',
                't2'=>'还有多少秒生产完成'
            )
        ),
        'succ_goods'=>array(//已经生产完成的物品
            array(
                'id'=>'生产物品的ID',
                't'=>'开始生产时间',
                't2'=>'生产完成时间',
                'n'=>'物品个数'
            )
        )
    ),
    "code"=>1
);

/*=========== 工厂生产产品完成的协议 end ==========*/

/*=========== 工厂购买生产位的协议 begin ==========*/
$socket_factory_open_seat_num = array(
    "a"=>"factory_open_seat_num",
    "m"=>"gzhq_factory",
    "d"=>array(
        'mf_id'=>'工厂ID',
        'num'=>'生产位ID(1或者2)'
    ),
    "code"=>1
);
//成功返回的信息：
$return_factory_open_seat_num = array(
    "ga"=>"factory_open_seat_num_bak",
    "gd"=>array(
        'mf_id'=>'工厂ID',
        'grade'=>'工厂等级',
        'open_seat_num'=>'已经打开的栏位数量'
    ),
    "code"=>1
);

/*=========== 工厂购买生产位的协议 end ==========*/


/*=========== 工厂建造的协议 begin ==========*/
$socket_factory_create = array(
    "a"=>"factory_create",
    "m"=>"gzhq_factory",
    "d"=>array(
        'mf_id'=>'工厂ID'
    ),
    "code"=>1
);
//成功返回的信息：
$return_factory_create = array(
    "ga"=>"factory_create_bak",
    "gd"=>array(
        'mf_id'=>'工厂ID',
        'grade'=>'工厂等级',
        'open_seat_num'=>'已经打开的栏位数量',
        'being_goods'=>array(//正在生产中的物品
            'id'=>'生产物品的ID',
            't'=>'还有多少秒生产完成'
        ),
        'queue_goods'=>array(//等待生产的物品
            array(
                'id'=>'生产物品的ID',
                't'=>'还有多少秒开始生产',
                't2'=>'还有多少秒生产完成'
            )
        ),
        'succ_goods'=>array(//已经生产完成的物品
            array(
                'id'=>'生产物品的ID',
                't'=>'开始生产时间',
                't2'=>'生产完成时间',
                'n'=>'物品个数'
            )
        )
    ),
    "code"=>1
);

/*=========== 工厂建造的协议 end ==========*/


/*=========== 工厂升级的协议 begin ==========*/
$socket_factory_up_grade = array(
    "a"=>"factory_up_grade",
    "m"=>"gzhq_factory",
    "d"=>array(
        'mf_id'=>'工厂ID'
    ),
    "code"=>1
);
//成功返回的信息：
$return_factory_up_grade = array(
    "ga"=>"factory_up_grade_bak",
    "gd"=>array(
        'mf_id'=>'工厂ID',
        'grade'=>'工厂等级',
        'open_seat_num'=>'已经打开的栏位数量',
        'being_goods'=>array(//正在生产中的物品
            'id'=>'生产物品的ID',
            't'=>'还有多少秒生产完成'
        ),
        'queue_goods'=>array(//等待生产的物品
            array(
                'id'=>'生产物品的ID',
                't'=>'还有多少秒开始生产',
                't2'=>'还有多少秒生产完成'
            )
        ),
        'succ_goods'=>array(//已经生产完成的物品
            array(
                'id'=>'生产物品的ID',
                't'=>'开始生产时间',
                't2'=>'生产完成时间',
                'n'=>'物品个数'
            )
        )
    ),
    "code"=>1
);

/*=========== 工厂升级的协议 end ==========*/


/*=========== 工厂生产产品完成后用户点击收获时的协议 begin ==========*/
$socket_factory_good_get = array(
    "a"=>"factory_good_save",
    "m"=>"gzhq_factory",
    "d"=>array(
        'mf_id'=>'工厂ID'
    ),
    "code"=>1
);
//成功返回的信息：
$return_send_factory_act = array(
    "ga"=>"factory_good_save_bak",
    "gd"=>array(
        'mf_id'=>'工厂ID',
        'grade'=>'工厂等级',
        'open_seat_num'=>'已经打开的栏位数量',
        'being_goods'=>array(//正在生产中的物品
            'id'=>'生产物品的ID',
            't'=>'还有多少秒生产完成'
        ),
        'queue_goods'=>array(//等待生产的物品
            array(
                'id'=>'生产物品的ID',
                't'=>'还有多少秒开始生产',
                't2'=>'还有多少秒生产完成'
            )
        ),
        'succ_goods'=>array(//已经生产完成的物品
            array(
                'id'=>'生产物品的ID',
                't'=>'开始生产时间',
                't2'=>'生产完成时间',
                'n'=>'物品个数'
            )
        )
    ),
    "code"=>1
);

/*=========== 工厂生产产品完成后用户点击收获时的协议 end ==========*/


//=======================工厂相关协议===================
//=======================工厂相关协议===================
//=======================工厂相关协议===================
//=======================begin 工厂相关协议===================

//==============begin 仓库相关操作协议=====================
/*=========== 获取仓库信息的协议 begin ==========*/
$http_store_info = array(
    "a"=>"store_info",
    "m"=>"store",
    "d"=>array(),
    "code"=>1
);
//成功返回的信息：
$return_store_info = array(
    "ga"=>"store_info_bak",
    "gd"=>array(
        'store_id'=>'仓库系统ID',
        'grade'=>'仓库等级',
        'num'=>'仓库总大小',
        'num2'=>'仓库已使用数量',
        'num3'=>'每格的大小',
        'name'=>'仓库名称',
        'data_info'=>array(//要获取的物品信息
            array(
                'good_id'=>'物品ID',
                'pos'=>'仓库位置',
                'num'=>'物品数量',
            ),
        )
    ),
    "code"=>1
);
/*=========== 获取仓库信息的协议 end ==========*/

/*=========== 从仓库出售物品的协议 begin ==========*/
$http_store_good_del = array(
    "a"=>"store_good_del",
    "m"=>"store",
    "d"=>array(
        'good_id'=>"物品ID",
        'num'=>"出售的数量"
    ),
    "code"=>1
);
//成功返回的信息：
$return_store_good_del = array(
    "ga"=>"store_good_del_bak",
    "gd"=>array(
        'store_id'=>'仓库系统ID',
        'good_id'=>'物品ID',
        'pos'=>'仓库位置',
        'num'=>'物品数量',
        'msg'=>'出售成功！'
    ),
    "code"=>1 //如果失败返回2
);
/*=========== 从仓库出售物品的协议 end ==========*/

/*=========== 仓库出升级的协议 begin ==========*/
$http_store_up_gread = array(
    "a"=>"store_up_gread",
    "m"=>"store",
    "d"=>array(
        'store_id'=>'仓库系统ID',
    ),
    "code"=>1
);
//成功返回的信息：
$return_store_up_gread = array(
    "ga"=>"store_up_gread_bak",
    "gd"=>array(
        'store_id'=>'仓库系统ID',
        'grade'=>'仓库等级',
        'num'=>'仓库总大小',
        'num2'=>'仓库已使用数量',
        'num3'=>'每格的大小',
        'name'=>'仓库名称'
    ),
    "code"=>1
);
/*=========== 仓库出升级的协议 end ==========*/

//==============end 仓库相关操作协议=====================


//================begin 订单相关操作协议=====================
/*=========== 获取当天订单列表的协议 begin ==========*/
$http_lottery_info = array(
    "a"=>"lottery_info",
    "m"=>"init",
    "d"=>array(),
    "code"=>1
);
//成功返回的信息：
$return_lottery_info = array(
    "ga"=>"lottery_info_bak",
    "gd"=>array(
        array(
            'lottery_id'=>'任务ID',
            'task_uid'=>'分配任务用户id',
            'task_uid_pic'=>'分配任务用户头像',
            'type'=>'任务类型',
            'is_ok'=>'是否已完成任务',
        ),
        array(
            'lottery_id'=>'任务ID',
            'task_uid'=>'分配任务用户id',
            'task_uid_pic'=>'分配任务用户头像',
            'type'=>'任务类型',
            'is_ok'=>'是否已完成任务',
        )
    ),
    "code"=>1
);
/*=========== 获取当天订单列表的协议 end ==========*/

/*=========== 用户订单入库的协议 begin ==========*/
$http_save_user_lottery_task = array(
    "a"=>"save_user_lottery_task",
    "m"=>"task",
    "d"=>array(),
    "code"=>1
);
//成功返回的信息：
$return_save_user_lottery_task = array(
    "ga"=>"save_user_lottery_task_bak",
    "gd"=>"文字说明",
    "code"=>1
);
/*=========== 用户订单入库的协议 end ==========*/

/*=========== 提交订单的协议 begin ==========*/
$socket_lottery_act = array(
    "a"=>"lottery_act",
    "m"=>"gzhq_lottery",
    "d"=>array(
        'lottery_id'=>'任务ID',
    ),
    "code"=>1
);
//成功返回的信息：
$return_lottery_act = array(
    "ga"=>"lottery_act_bak",
    "gd"=>array(
        'lottery_id'=>'任务ID',
        'task_uid'=>'分配任务用户id',
        'task_uid_pic'=>'分配任务用户头像',
        'type'=>'任务类型',
        'is_ok'=>'是否已完成任务',
        'msg'=>'提交订单成功'
    ),
    "code"=>1
);
/*=========== 提交订单的协议 end ==========*/
//================end 订单相关操作协议=======================


/*=========== 玩家信息框获取的协议 begin ==========*/
$http_user_count_info = array(
    "a"=>"user_count_info",
    "m"=>"init",
    "d"=>array(
    ),
    "code"=>1
);
//成功返回的信息：
$return_lottery_act = array(
    "ga"=>"user_count_info_bak",
    "gd"=>array(
        'flower_num'=>'种植的花卉总数',
        'order_num'=>'完成的订单总数',
        'goods_num'=>'制造的商品总数',
        'up_time'=>'数据更新时间',
    ),
    "code"=>1
);
/*=========== 玩家信息框获取的协议 end ==========*/




//============begin服务器主动通知协议================
//每当用户经验到达可升级时，给客户端推送用户升级提示信息：
$return_send_user_grade_up = array(
    "ga"=>"send_user_grade_up",
    "gd"=>array(
        'grade'=>"原等级",
        'grade2'=>"新等级",
        'num'=>"0",//'玩家增加金币数量',
        'up_data'=>array(//解锁说明
            array(
				'id'=>"hh01",//物品id
				'num'=>"2" //要求数量
			),
			array(
				'id'=>"hh01",//物品id
				'num'=>"2" //要求数量
			)
        ),
        'msg'	=> '升级说明文字'
    ),
    "code"=>1
);

//每当用户的属性发生改变时，
//给客户端推送消息（与用户性基本信息用同一条协议）
$return_send_user_have_gold = array(
    "ga"=>"init_info",
    "gd"=>array(
        'have_gold'=>'可用金币',
        'grade'=>'等级',
        'exp'=>'当前等级经验',
        'upgrade_exp'=>'升级经验'
    ),
    "code"=>1
);


//============end服务器主动通知协议================

/*=========== 客户端加载数据配置请求协议 begin ==========*/
$http_data_config_info = array(
    "a"=>"data_config_info",
    "m"=>"init",
    "d"=>array(
    ),
    "code"=>1
);
//成功返回的信息：
$return_data_config_info = array(
    "ga"=>"data_config_info_bak",
    "gd"=>array(
        'SYS_STORE_INFO'=>array(),//仓库配置
        'SYS_FACTORY_INFO'=>array(),//工厂数据
        'SYS_FLOWER_PLANTS'=>array(),//花卉数据
        'SYS_FLOWER_FIELD'=>array(),//花田数据
        'SYS_FLOWER_WATER'=>array(),//浇水数据
        'SYS_FLOWER_LOTTERY'=>array(),//任务数据
        'SYS_FACTORY_GOOD'=>array(),//工厂可生产的物品数据(这里的物品都会在 物品数据 里有配置的)
        'SYS_FLOWER_COMPOSTED'=>array(),//施肥数据
        'SYS_FLOWER_MEMBER'=>array(),//玩家初始数据
        'SYS_GOOD_INFO'=>array()//物品数据
    ),
    "code"=>1
);
/*=========== 客户端加载数据配置请求协议 end ==========*/





